#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <errno.h>
//#include <sys/socket.h>
#include <netinet/in.h>
//#include <unistd.h>
#include <fcntl.h>
//#include <dirent.h>

//#include <netdb.h>
#define max(a,b) ((a) > (b) ? (a) : (b))
#define COMMAND_LENGTH 80
#define MAX_ARGS 5

/** Esecuzione di un comando ricevuto tramite stringa **/
void esegui(char* stringa,int out){
  int beforeSpace = 1,cont1,cont2=0,cont3=0;
  char* argomenti[MAX_ARGS];
  for(cont1=0;cont1<MAX_ARGS;cont1++) argomenti[cont1] = malloc(COMMAND_LENGTH*sizeof(char));
  cont1=-1;
  while(stringa[++cont1] != '\0'){
    if(stringa[cont1]==' '){
      argomenti[cont3][cont2]='\0';
      if(beforeSpace==0) cont3++;
      cont2=0;
      beforeSpace=1;
    }else{
      argomenti[cont3][cont2++] = stringa[cont1];
      beforeSpace=0;
    }
  }
  if(argomenti[cont3][0]!='\0') cont3++;
  argomenti[cont3]=NULL;
  if(out==0){
    // chiudo l'utput a video e lo stderror per il figlio che esegue;
    close(1);
    close(2);
    open("/dev/null",O_WRONLY);
    open("/dev/null",O_WRONLY);
  }
  execvp(argomenti[0],argomenti);
}
/****/

/** Gestione dei segnali di morte dei figli usata per il server stream **/
void gestore(int signo){
  int stato;
  wait(&stato);
}
/****/

int main(int argc, char* argv[])
{
  int  sockListen, sockDgram, sockStream, maxSock;
  const int on = 1;
  fd_set rset;
  int len, num, port;
  struct sockaddr_in cliaddr, servaddr;

  /** Controllo argomenti **/
  if(argc!=2){
    printf("Error: %s port\n", argv[0]);
    exit(1);
  }
  num=0;
  while(argv[1][num]!='\0'){
    if(argv[1][num]<'0' || argv[1][num] >'9'){
      printf("port must be a number!\n");
      exit(2);
    }
    num++;
  }
  port = atoi(argv[1]);
  /****/
  
  /** Inizializzo indirizzo del server **/
  memset ((char *)&servaddr, 0, sizeof(servaddr));
  servaddr.sin_family = AF_INET;
  servaddr.sin_addr.s_addr = INADDR_ANY;
  servaddr.sin_port = htons(port);
  /****/

  /** Creazione socket stream - TCP **/
  sockListen=socket(AF_INET, SOCK_STREAM, 0);
  if (sockListen <0){
    perror("apertura socket TCP ");
    exit(2);
  }
  if (setsockopt(sockListen, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on))<0){
    perror("set opzioni socket TCP");
    exit(3);
  }
  if (bind(sockListen,(struct sockaddr *) &servaddr, sizeof(servaddr))<0){
    perror("bind socket TCP");
    exit(4);
  }
  if (listen(sockListen, 5)<0){
    perror("sockListen");
    exit(5);
  }
  /****/

  /** Creazione socket Datagram - UDP **/
  sockDgram=socket(AF_INET, SOCK_DGRAM, 0);
  if(sockDgram <0){
    perror("apertura socket UDP");
    exit(6);
  }
  if(setsockopt(sockDgram, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on))<0){
    perror("set opzioni socket UDP");
    exit(7);
  }
  if(bind(sockDgram,(struct sockaddr *) &servaddr, sizeof(servaddr))<0){
    perror("bind socket UDP");
    exit(8);
  }
  /****/

  /** Azzeramento maschera per la select e settaggio variabile socket più "alta" **/
  FD_ZERO(&rset);
  maxSock=max(sockListen, sockDgram)+1;
  /****/
  
  len=sizeof(struct sockaddr_in);
  printf("Server ON\n");
  
  /** Ricezione eventi dalla select **/
  for(;;){
    FD_SET(sockListen, &rset);
    FD_SET(sockDgram, &rset);
    if ((select(maxSock, &rset, NULL, NULL, NULL))<0){
      if (errno==EINTR) continue; //segnale causato dalla morte di un figlio
      else {
        perror("select");
        exit(9);
      }
    }
    if (FD_ISSET(sockListen, &rset)){
      
      /** Gestione richiesta su socket a stream **/
      if((sockStream = accept(sockListen,(struct sockaddr *)&cliaddr,&len))<0){
        if (errno==EINTR) continue;
        else {
          perror("accept");
          exit(10);
        }
      }
      
      /** CORPO DELLA GESTIONE STREAM **/
      
      //gestione della morte dei figli affidata al mio gestore
      signal(SIGCHLD, gestore);
      int pid = fork();
      if(pid==0){  
        // figlio
        char c,stringa[FILENAME_MAX+1];
        int intero,num1;
          // lettura stringa da socket
        num1=0;
        while(1){
          if( read(sockStream,&c,sizeof(char)) < 0){
            perror("Lettura da socket");
            break;
          }
          stringa[num1]=c;
          if(c=='\0') break;
          num1++;
        }
        // redirigo l'output verso la socket
        close(1);
        dup(sockStream);
        close(sockStream);
        esegui(stringa,1);
        exit(1); //in caso di fallimento devo far morire il figlio
      }
      else if(pid>0){
        //padre
        close(sockStream);
        continue;
      } else{
        perror("fork");
        continue;
      }
      /** FINE CORPO GESTIONE **/ 
      
      /****/
      
    } else if (FD_ISSET(sockDgram, &rset)){      
      /** CORPO DELLA GESTIONE DATAGRAM **/
      
      // la morte dei figli viene gestita in maniera sincrona dal padre
      signal(SIGCHLD, SIG_DFL);
      /*
       * metto la receive nel padre perchè se la fa il figlio al padre non resta traccia del cliente, quindi non sa
       * a chi rispondere in seguito. Altra soluzione potrebbe essere di far inviare al client un carattere prima della
       * stringa vera e propria, far leggere quel carattere al padre e poi la stringa al figlio.
       */
      char stringa[COMMAND_LENGTH];
        if (recvfrom(sockDgram, stringa, sizeof(stringa), 0, (struct sockaddr *)&cliaddr, &len)<0){
          perror("recvfrom");
          continue;
      }
      int pid = fork();
      if(pid==0){
        //figlio
        esegui(stringa,0);
        exit(-1); //se la esegui fallisce il figlio termina comunque
      }else{
        //padre
        int status, response;
        if(waitpid(pid, &status, 0)<0){
          perror("waitpid");
        }
        if(WIFEXITED(status)) response = WEXITSTATUS(status);
        else response = -1;
        response = htonl(response);
        if (sendto(sockDgram, &response, sizeof(int), 0, (struct sockaddr *)&cliaddr, len)<0){
          perror("scrittura socket");
          exit(2);
        }
      }
      /** FINE CORPO GESTIONE **/
    }
  }
  /****/
}

